package com.contextspace.example;

import java.io.Serializable;
import java.util.Date;

import javax.jdo.annotations.Index;
import javax.persistence.Entity;
import javax.persistence.GeneratedValue;
import javax.persistence.GenerationType;
import javax.persistence.Id;
import javax.persistence.TableGenerator;
import javax.persistence.Temporal;
import javax.persistence.TemporalType;

@Entity
@TableGenerator(name="IdTableGen", initialValue=1, allocationSize=50)
public class CDI implements Serializable{
    private static final long serialVersionUID = 1L;
   
    private Date creationDate = null;
    private String firstname = null;
    private String lastname = null;
    
    private long id;
    
    /**
     * Default Constructor
     */
    public CDI() {
        
    }
    
    /**
     * Constructor
     * @param firstname
     * @param lastname
     */
    public CDI(String firstname, String lastname) {
        this.firstname = firstname;
        this.lastname = lastname;
        this.creationDate = new Date();
    }
    
    /**
     * Constructor
     * @param firstname
     * @param lastname
     * @param creationDate
     */
    public CDI(String firstname, String lastname, Date creationDate) {
        this.firstname = firstname;
        this.lastname = lastname;
        this.creationDate = creationDate;
    }
        
    /**
     * @return the creationDate
     */
    @Temporal(TemporalType.TIMESTAMP)
    public Date getCreationDate() {
        return creationDate;
    }
    
    /**
     * @param creationDate the creationDate to set
     */
    public void setCreationDate(Date creationDate) {
        this.creationDate = creationDate;
    }
    
    /**
     * @return the object id
     */
    @Id
    @GeneratedValue(strategy=GenerationType.TABLE, generator="IdTableGen")
    public long getId() {
        return id;
    }

    /**
     * @param id the id to be set
     */
    public void setId(long id) {
        this.id = id;
    }

    /**
     * @return the firstname
     */
    @Index(unique="false")
    public String getFirstname() {
        return firstname;
    }

    /**
     * @param firstname the firstname to set
     */
    public void setFirstname(String firstname) {
        this.firstname = firstname;
    }

    /**
     * @return the lastname
     */
    @Index(unique="false")
    public String getLastname() {
        return lastname;
    }

    /**
     * @param lastname the lastname to set
     */
    public void setLastname(String lastname) {
        this.lastname = lastname;
    }
    
}
